package gelwood.crossword;

import java.util.Iterator;
import java.util.ArrayList;

public class AcrossIterator implements Iterator<Square> {
	
	private boolean nextBool;
	private ArrayList<Square> gridArray;
	private boolean nextIsStart;
	
	private int index;
	private int width;
	private int height;
	
	private int row;
	private int column;
	
	
	public AcrossIterator(Grid grid){
		this.nextBool = true;
		this.gridArray = grid.getGrid();
		this.nextIsStart = true;
		this.index = 0;
		this.width = grid.getWidth();
		this.height = grid.getHeight();
		this.row = 0;
		this.column = 0;
		
	}
	
	public boolean hasNext() {
		return this.nextBool;
	}

	public Square next() {
		
		Square mySquare = this.gridArray.get(this.index);
		
		Square myNext = null;
		
		int end = (this.width * this.height);
		
		int last = ((this.row + 1) * (this.width)) - 1;
		
		if (column == 0 ) {
			mySquare.rowStart = true;
		}
		
		if ((this.index + 1)  < end) {
			myNext = this.gridArray.get(this.index + 1);
		}
		
		if (
			nextIsStart && 
			(mySquare instanceof BlankSquare) &&
			(myNext instanceof BlankSquare) )
		{
			((BlankSquare)mySquare).makeAcross();
			nextIsStart = false;
		}
		
		if (mySquare instanceof BlackSquare) {
			nextIsStart = true;
		}
		
		if ((this.index + 1) <= last) {
			this.index = this.index + 1;
			this.column = this.column + 1;
		} else {
			this.row = this.row + 1;
			this.column = 0;
			this.index = this.index + 1;
			nextIsStart = true;
		}
		
		if (this.index == (this.height * this.width)) {
			this.nextBool = false;
		}
	

		
		return mySquare;
	}

	public void remove() {
		System.out.println("AcrossIterator.remove() is not implemented.");

		
	}

}
