package gelwood.crossword;


public class BlankSquare extends Square{
	
	private int number;
	private char letter;
	

	public BlankSquare(){
		this.blank = true;
		this.downStart = false;
		this.acrossStart = false;
		this.number = 0;
		this.letter = '.';
		this.intersection = false;
		this.rowStart = false;
		this.columnStart = false;
	}
	
	protected BlankSquare(char myChar){
		this.blank = true;
		this.downStart = false;
		this.acrossStart = false;
		this.number = 0;
		this.letter = myChar;
		this.intersection = false;
	}
	
	protected BlankSquare(Square oldSquare) {
		this.blank = oldSquare.blank;
		this.downStart = oldSquare.downStart;
		this.acrossStart = oldSquare.acrossStart;
		
		if (oldSquare instanceof BlankSquare) {
			this.number = ((BlankSquare)oldSquare).getNumber();
			this.letter = ((BlankSquare)oldSquare).getLeter();
			
		} else {
			this.number = 0;
			this.letter = '?';
			
		}
		
		this.intersection = oldSquare.isIntersection();
	}

	protected char getLeter(){
		return this.letter;
	}
	
	protected void makeIntersection(){
		this.intersection = true;
	}
	
	
	public void print() {
		System.out.print(this.letter);
	}
	
	protected void setNumber(int number){
		this.number = number;
	}
	
	protected void setLetter(char myChar) {
		this.letter = myChar;
	}
	
	public void makeDown(){
		this.downStart = true;
	}
	
	public void makeAcross(){
		this.acrossStart = true;
	}
	
	public int getNumber(){
		return this.number;
	}
	
	public boolean isDown(){
		return this.downStart;
	}
	
	public boolean isAcross(){
		return this.acrossStart;
	}
}

