package gelwood.crossword;

import java.util.Iterator;
import java.util.ArrayList;

public class DownIterator implements Iterator<Square> {
	private int height;
	private int width;
	private int index;
	private int row;
	private int column;
	private ArrayList<Square> gridArray;
	private boolean nextBool;
	
	private boolean nextIsStart;
	
	public DownIterator(Grid myGrid){
		this.height = myGrid.getHeight();
		this.width = myGrid.getWidth();
		this.index = 0;
		this.row = 0;
		this.column = 0;
		this.gridArray = myGrid.getGrid();	
		this.nextBool = true;
		
		this.nextIsStart = true;
	}
	
	public boolean hasNext(){
		return this.nextBool;
	}
	
	public Square next(){
		int bottom = ((this.height * (this.width - 1 )) + this.column);
		
		Square mySquare = this.gridArray.get(this.index);
		
		Square myNext = null;
		
		if (this.row == 0){
			mySquare.columnStart = true;
		}
		
		if (((this.index + this.width) <= bottom)) {
			myNext = this.gridArray.get(this.index + this.width); 
		}
		
		if (
			nextIsStart && 
			(mySquare instanceof BlankSquare) &&
			(myNext instanceof BlankSquare) ) 
		{
			((BlankSquare)mySquare).makeDown();
			nextIsStart = false;
		}
		
		if (mySquare instanceof BlackSquare) {
			nextIsStart = true;
		}
		
		if ((this.index + this.width) <= bottom) {
			this.index = this.index + this.width;
			this.row = this.row + 1;
		} else {
			this.row = 0;
			this.column = this.column + 1;
			this.index = this.column;
			nextIsStart = true;
		}
		
		if (this.column == this.width) {
			this.nextBool = false;
		}
		
		return mySquare;
	}

	public void remove() {
		System.out.println("DownIterator.remove() is not implemented.");
		
	}
}

