package gelwood.crossword;

import java.util.Iterator;
import java.util.ArrayList;

public class NumberIterator implements Iterator<Square>{
	
	private ArrayList<Square> gridArray;
	private int size;
	private int index;
	private int number;
	
	public NumberIterator(Grid grid) {
		this.gridArray = grid.getGrid();
		this.size = this.gridArray.size();
		this.index = 0;
		this.number = 1;
		
	}
	
	public boolean hasNext() {
		return (this.index < this.size);
	}

	public Square next() {
		Square mySquare = this.gridArray.get(index);
		
		
		if (mySquare instanceof BlankSquare) {
			BlankSquare myBlank = (BlankSquare)mySquare;
			if ((mySquare.isDownStart()) || mySquare.isAcrossStart()) {
			
				myBlank.setNumber(this.number);
				this.number = this.number + 1;
			}
		}
		this.index = this.index + 1;
		
		return mySquare;
	}

	public void remove() {
		System.out.println("NumberIterator.remove() is not implemented.");
		
	}

}

