package gelwood.crossword;

import java.io.FileInputStream;


public class Test {
	
	
	static String grid1 = 
		"......\n" +
		"......\n" +
		"......\n" +
		"......\n" +
		"......\n";
	
	static String grid2 = 
		"#######\n" +
		"#######\n" +
		"#######\n" +
		"#######\n";
	
	//xtra.grid
	static String grid3 = 
		"......#...#....\n" +
		"......#...#....\n" +
		"......#...#....\n" +
		"###............\n" +
		".....#...#.....\n" +
		"....#...#...###\n" +
		"...#...#.......\n" +
		"...#...#...#...\n" +
		".......#...#...\n" +
		"###...#...#....\n" +
		".....#...#.....\n" +
		"............###\n" +
		"....#...#......\n" +
		"....#...#......\n" +
		"....#...#......\n";
	
	//hard1.grid
	static String grid4 =
		".....#.....#...\n" +
		".....#.....#...\n" +
		".....#.........\n" +
		"###............\n" +
		".......##......\n" +
		"......#......##\n" +
		".....#........#\n" +
		"....#.....#....\n" +
		"#........#.....\n" +
		"##......#......\n" +
		"......##.......\n" +
		"............###\n" +
		".........#.....\n" +
		"...#.....#.....\n" +
		"...#.....#.....\n";
	
	static String grid5 = 
		"..#......\n" +
		"...#.....\n" +
		"....#....\n" +
		"##...#...\n" +
		"..#...#..\n" +
		"....#....\n" +
		"...#.....\n" +
		"..#...#..\n" +
		"..#..#...\n" ;
	
	static String grid6 = 
		".#....\n" +
		"..#...\n" +
		"...#..\n" +
		"....#.\n" +
		".....#\n" +
		"......\n";
	
	static String grid7 = 
		".......\n" +
		"#......\n" +
		".#.....\n" +
		"..#....\n" +
		"...#...\n" +
		"....#..\n" +
		"......#\n";
	
	static String grid8 =
		"....\n" +
		"#...\n" +
		"...#\n" +
		"....\n";
	
	static String grid9 = 
		".#..\n" +
		"....\n" +
		"....\n" +
		"..#.\n";
	
	static String grid10 = 
		".....\n" +
		".#...\n" +
		"....#\n" +
		".....\n";
	
		
	
	
	
	String dictString = fileToString("dictionary.txt"); 
	
	public void run(){
		
		testGrid(grid1, dictString);
		
		testGrid(grid2, dictString);
		
		testGrid(grid3, dictString);
		
		testGrid(grid4, dictString);
//		
//		testGrid(grid5, dictString);
//		
//		testGrid(grid6, dictString);
//		
//		testGrid(grid7, dictString);
//		
//		testGrid(grid8, dictString);
//		
//		testIterators(grid1);
//		
//		testIterators(grid8);
//		
//		testIterators(grid9);
//		
//		testIterators(grid10);
	}

	
	public void testGrid(String grid, String dictionaryString){
		Dictionary myDictionary = new Dictionary(dictionaryString);
		Grid myGrid = new Grid(grid);
		
		myGrid.setupSubDictionaries(myDictionary);
		
//		myGrid.printIntersection();
//		
//		myGrid.printRowStarts();
//		
//		myGrid.printColumnStarts();
		
		System.out.println();
		
		numberGrid(myGrid);
		
		
		
		myGrid.sortWordsByWeight();
		
		
		
		myGrid.print();
		
		System.out.println();
		
		myGrid.printWords();
		
		System.out.println();
		
		
	}
	
	public void numberGrid(Grid myGrid){
		int i = 0;
		int x = 65;
		while (i < myGrid.size()) {
			Square mySquare = myGrid.getSquare(i);
			if (mySquare instanceof BlankSquare) {
				((BlankSquare) mySquare).setLetter((char)x);
				x = x + 1;
				if (x > 125){
					x = 65;
				}
			} 
			i = i + 1;
		}
	}
	
	public void testIterators(String grid){
		Grid myGrid = new Grid(grid);
		
		DownIterator di = new DownIterator(myGrid);
		AcrossIterator ai = new AcrossIterator(myGrid);
		
		myGrid.print();
		
		System.out.println();
		
		while(di.hasNext()){
			Square mySquare = di.next();
			mySquare.print();
		}
	
		System.out.println();
		
		while(ai.hasNext()){
			Square mySquare = ai.next();
			mySquare.print();
		}
		
		System.out.println();
		
	}
	
	private String fileToString(String path){
		byte[] myBytes = null;
		
		try {
			FileInputStream myFile = new FileInputStream(path);
			myBytes = new byte[myFile.available()];
			myFile.read(myBytes);
			myFile.close();
		} catch (Exception e) {
			System.out.println("Exception in Grid.fileToString: " + e);
		}
		
		return new String(myBytes);
	}
	

	
}
